/* DChub - a Direct Connect Hub for Linux
 * Copyright (C) 2001 Eric Prevoteau
 *
 * gvar.h: Copyright (C) Eric Prevoteau <www@ac2i.tzo.com>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */

#ifndef __GVAR_H__
#define __GVAR_H__

#include "edb_warper.h"

#define OP_PRIV		1
#define MASTER_PRIV	2
#define BOT_PRIV	4
#define HUB_PRIV	8
#define FUSION_PRIV	16

#include <regex.h>
extern regex_t *gl_lock_patern;
extern time_t gl_cur_time;

extern unsigned short reg_hub_port;

/****************************************************/
/* to manage simultaneous incoming user connections */
/****************************************************/
extern int remaining_allowed_incoming_cnx;
G_LOCK_EXTERN(remaining_allowed_incoming_cnx);


/**********************/
/* configuration file */
/**********************/
extern  t_db_sym **conf_file;
G_LOCK_EXTERN(conf_file);
extern char *conf_filename;     /* name of the configuration file (to use with edb) */

/*************/
/* user file */
/*************/
extern FILE *user_file;
G_LOCK_EXTERN(user_file);

/***************************************/
/* some vars used for Perl interpreter */
/* these vars are READ-ONLY.           */
/***************************************/
extern char *perl_script_dir;
extern char *perl_script_main;

/*****************************************/
/* some vars used for Python interpreter */
/* these vars are READ-ONLY.             */
/*****************************************/
extern char *python_script_dir;
extern char *python_main_script;

/*****************************************/
/* somes vars used for external programs */
/*****************************************/
extern char *ext_prog_dir;

extern int	gl_sr_interval;
extern int	gl_moderate_mode;
extern int	gl_silent_limit;
extern int	gl_kick_limit;


#endif
